
' How To Write A Chess Program in QBASIC
' By Dean Menezes

#lang "fblite"
option gosub

declare sub SHOWMAN(A, B, FLAG)
declare sub SHOWBD()
declare sub IO(A, B, X, Y, RESULT)
declare function INCHECK(X)
declare sub MAKEMOVE(A, B, X, Y)
declare sub KNIGHT(A, B, XX(), YY(), NDX)
declare sub KING(A, B, XX(), YY(), NDX)
declare sub QUEEN(A, B, XX(), YY(), NDX)
declare sub ROOK(A, B, XX(), YY(), NDX)
declare sub BISHOP(A, B, XX(), YY(), NDX)
declare sub MOVELIST(A, B, XX(), YY(), NDX)
declare sub PAWN(A, B, XX(), YY(), NDX)
declare function EVALUATE(ID, PRUNE)
dim shared BOARD(0 to 7, 0 to 7)
dim shared BESTA(0 to 7), BESTB(0 to 7), BESTX(0 to 7), BESTY(0 to 7)
dim shared LEVEL, MAXLEVEL, SCORE, CFLAG
CFLAG = 0
LEVEL = 0
MAXLEVEL = 5

data  -500, -270, -300, -900,-7500, -300, -270, -500
data  -100, -100, -100, -100, -100, -100, -100, -100
data     0,    0,    0,    0,    0,    0,    0,    0
data     0,    0,    0,    0,    0,    0,    0,    0
data     0,    0,    0,    0,    0,    0,    0,    0
data     0,    0,    0,    0,    0,    0,    0,    0
data   100,  100,  100,  100,  100,  100,  100,  100
data   500,  270,  300,  900, 5000,  300,  270,  500

for Y = 0 to 7
  for X = 0 to 7
    read Z
    BOARD(Y, X) = Z
  next X
next Y

A = -1
RESULT = 0
do
  SCORE = 0
  call IO(A, B, X, Y, RESULT)
  RESULT = EVALUATE(-1, 10000)
  A = BESTA(1)
  B = BESTB(1)
  X = BESTX(1)
  Y = BESTY(1)
loop

sub BISHOP(A, B, XX(), YY(), NDX)
  ID = sgn(BOARD(B, A))
  
  for DXY = 1 to 7
    X = A - DXY
    Y = B + DXY
    if X < 0 or X > 7 or Y < 0 or Y > 7 then exit for
    gosub 3
    if BOARD(Y, X) then exit for
  next
  
  for DXY = 1 to 7
    X = A + DXY
    Y = B + DXY
    if X < 0 or X > 7 or Y < 0 or Y > 7 then exit for
    gosub 3
    if BOARD(Y, X) then exit for
  next
  
  for DXY = 1 to 7
    X = A - DXY
    Y = B - DXY
    if X < 0 or X > 7 or Y < 0 or Y > 7 then exit for
    gosub 3
    if BOARD(Y, X) then exit for
  next
  
  for DXY = 1 to 7
    X = A + DXY
    Y = B - DXY
    if X < 0 or X > 7 or Y < 0 or Y > 7 then exit for
    gosub 3
    if BOARD(Y, X) then exit for
  next
  
  exit sub
  
  3
  if ID <> sgn(BOARD(Y, X)) then
    NDX = NDX + 1
    XX(NDX) = X
    YY(NDX) = Y
  end if
  return
end sub

function EVALUATE(ID, PRUNE)
  dim XX(0 to 26), YY(0 to 26)
  LEVEL = LEVEL + 1
  BESTSCORE = 10000 * ID
  for B = 7 to 0 step -1
    for A = 7 to 0 step -1
      if sgn(BOARD(B, A)) <> ID then goto 1
      call MOVELIST(A, B, XX(), YY(), NDX)
      for I = 0 to NDX
        X = XX(I)
        Y = YY(I)
        OLDSCORE = SCORE
        MOVER = BOARD(B, A)
        TARGET = BOARD(Y, X)
        call MAKEMOVE(A, B, X, Y)
        if LEVEL < MAXLEVEL then SCORE = SCORE + EVALUATE(-ID, BESTSCORE - TARGET + ID * (8 - abs(4 - X) - abs(4 - Y)))
        SCORE = SCORE + TARGET - ID * (8 - abs(4 - X) - abs(4 - Y))
        if (ID < 0 and SCORE > BESTSCORE) or (ID > 0 and SCORE < BESTSCORE) then
          BESTA(LEVEL) = A
          BESTB(LEVEL) = B
          BESTX(LEVEL) = X
          BESTY(LEVEL) = Y
          BESTSCORE = SCORE
          if (ID < 0 and BESTSCORE >= PRUNE) or (ID > 0 and BESTSCORE <= PRUNE) then
            BOARD(B, A) = MOVER
            BOARD(Y, X) = TARGET
            SCORE = OLDSCORE
            LEVEL = LEVEL - 1
            EVALUATE = BESTSCORE
            exit function
          end if
        end if
        BOARD(B, A) = MOVER
        BOARD(Y, X) = TARGET
        SCORE = OLDSCORE
      1 next
    next
  next
  LEVEL = LEVEL - 1
  EVALUATE = BESTSCORE
end function

function INCHECK(X)
  dim XX(27), YY(27), NDX
  for B = 0 to 7
    for A = 0 to 7
      if BOARD(B, A) >= 0 then goto 6
      call MOVELIST(A, B, XX(), YY(), NDX)
      for I = 0 to NDX step 1
        X = XX(I)
        Y = YY(I)
        if BOARD(Y, X) = 5000 then
          'PRINT "YOU ARE IN CHECK!"
          INCHECK = 1
          exit function
        end if
      next
    6 next
  next
  INCHECK = 0
end function

sub IO(A, B, X, Y, RESULT)
  dim XX(0 to 26), YY(0 to 26)
  
  if A >= 0 then
    if RESULT < -2500 then
      'PRINT "I RESIGN"
      system
    end if
    'PIECE = BOARD(Y, X)
    call MAKEMOVE(A, B, X, Y)
    
    print "<"; chr(65 + A, 8 - B + asc("0"), 65 + X, 8 - Y + asc("0"))
    NULL = INCHECK(0)
  end if
  
  do
    call SHOWBD
    input ">", IN$
    if UCASE$(IN$) = "QUIT" then end
    if UCASE$(IN$) = "O-O" then
      if CFLAG then goto 16
      if BOARD(7, 7) <> 500 then goto 16
      if BOARD(7, 6) or BOARD(7, 5) then goto 16
      BOARD(7, 6) = 5000
      BOARD(7, 4) = 0
      BOARD(7, 5) = 500
      BOARD(7, 7) = 0
      CFLAG = 1
      exit sub
    end if
    if UCASE$(IN$) = "O-O-O" then
      if CFLAG then goto 16
      if BOARD(7, 0) <> 500 then goto 16
      if BOARD(7, 1) or BOARD(7, 2) or BOARD(7, 3) then goto 16
      BOARD(7, 2) = 5000
      BOARD(7, 4) = 0
      BOARD(7, 3) = 500
      BOARD(7, 0) = 0
      CFLAG = 1
      exit sub
    end if
    
    if len(IN$) < 4 then goto 16
    
    A = asc(UCASE$(MID$(IN$, 1, 1))) - 65
    B = 8 - (asc(MID$(IN$, 2, 1)) - 48)
    X = asc(UCASE$(MID$(IN$, 3, 1))) - 65
    Y = 8 - (asc(MID$(IN$, 4, 1)) - 48)
    
    if B > 7 or B < 0 or A > 7 or A < 0 or X > 7 or X < 0 or Y > 7 or Y < 0 then goto 16
    if BOARD(B, A) <= 0 then goto 16
    
    call MOVELIST(A, B, XX(), YY(), NDX)
    
    for K = 0 to NDX step 1
      if X = XX(K) and Y = YY(K) then
        MOVER = BOARD(B, A)
        TARGET = BOARD(Y, X)
        call MAKEMOVE(A, B, X, Y)
        if INCHECK(0) = 0 then exit sub
        BOARD(B, A) = MOVER
        BOARD(Y, X) = TARGET
        goto 16
      end if
    next
    16
  loop
end sub

sub KING(A, B, XX(), YY(), NDX)
  ID = sgn(BOARD(B, A))
  for DY = -1 to 1
    if B + DY < 0 or B + DY > 7 then goto 12
    for DX = -1 to 1
      if A + DX < 0 or A + DX > 7 then goto 11
      if ID <> sgn(BOARD(B + DY, A + DX)) then
        NDX = NDX + 1
        XX(NDX) = A + DX
        YY(NDX) = B + DY
      end if
    11 next
  12 next
end sub

sub KNIGHT(A, B, XX(), YY(), NDX)
  ID = sgn(BOARD(B, A))
  X = A - 1
  Y = B - 2
  gosub 5
  X = A - 2
  Y = B - 1
  gosub 5
  X = A + 1
  Y = B - 2
  gosub 5
  X = A + 2
  Y = B - 1
  gosub 5
  X = A - 1
  Y = B + 2
  gosub 5
  X = A - 2
  Y = B + 1
  gosub 5
  X = A + 1
  Y = B + 2
  gosub 5
  X = A + 2
  Y = B + 1
  gosub 5
  exit sub
  5 if X < 0 or X > 7 or Y < 0 or Y > 7 then return
  if ID <> sgn(BOARD(Y, X)) then NDX = NDX + 1: XX(NDX) = X: YY(NDX) = Y
  return
end sub

sub MAKEMOVE(A, B, X, Y)
  BOARD(Y, X) = BOARD(B, A)
  BOARD(B, A) = 0
  if Y = 0 and BOARD(Y, X) = 100 then BOARD(Y, X) = 900
  if Y = 7 and BOARD(Y, X) = -100 then BOARD(Y, X) = -900
end sub

sub MOVELIST(A, B, XX(), YY(), NDX)
  PIECE = int(abs(BOARD(B, A)))
  NDX = -1
  if PIECE = 100 then
    call PAWN(A, B, XX(), YY(), NDX)
  elseif PIECE = 270 then call KNIGHT(A, B, XX(), YY(), NDX)
  elseif PIECE = 300 then call BISHOP(A, B, XX(), YY(), NDX)
  elseif PIECE = 500 then call ROOK(A, B, XX(), YY(), NDX)
  elseif PIECE = 900 then call QUEEN(A, B, XX(), YY(), NDX)
  else call KING(A, B, XX(), YY(), NDX)
  end if
end sub

sub PAWN(A, B, XX(), YY(), NDX)
  ID = sgn(BOARD(B, A))
  if (A - 1) >= 0 and (A - 1) <= 7 and (B - ID) >= 0 and (B - ID) <= 7 then
    if sgn(BOARD((B - ID), (A - 1))) = -ID then
      NDX = NDX + 1
      XX(NDX) = A - 1
      YY(NDX) = B - ID
    end if
  end if
  if (A + 1) >= 0 and (A + 1) <= 7 and (B - ID) >= 0 and (B - ID) <= 7 then
    if sgn(BOARD((B - ID), (A + 1))) = -ID then
      NDX = NDX + 1
      XX(NDX) = A + 1
      YY(NDX) = B - ID
    end if
  end if
  if A >= 0 and A <= 7 and (B - ID) >= 0 and (B - ID) <= 7 then
    if BOARD((B - ID), A) = 0 then
      NDX = NDX + 1
      XX(NDX) = A
      YY(NDX) = B - ID
      if (ID < 0 and B = 1) or (ID > 0 and B = 6) then
        if BOARD((B - ID - ID), A) = 0 then
          NDX = NDX + 1
          XX(NDX) = A
          YY(NDX) = B - 2 * ID
        end if
      end if
    end if
  end if
end sub

sub QUEEN(A, B, XX(), YY(), NDX)
  call BISHOP(A, B, XX(), YY(), NDX)
  call ROOK(A, B, XX(), YY(), NDX)
end sub

sub ROOK(A, B, XX(), YY(), NDX)
  ID = sgn(BOARD(B, A))
  
  for X = A - 1 to 0 step -1
    if ID <> sgn(BOARD(B, X)) then
    NDX = NDX + 1
    XX(NDX) = X
    YY(NDX) = B
    end if
    if (BOARD(B, X)) then exit for
  next
  
  for X = A + 1 to 7 step 1
    if ID <> sgn(BOARD(B, X)) then
    NDX = NDX + 1
    XX(NDX) = X
    YY(NDX) = B
    end if
    if (BOARD(B, X)) then exit for
  next
  
  for Y = B - 1 to 0 step -1
    if ID <> sgn(BOARD(Y, A)) then
    NDX = NDX + 1
    XX(NDX) = A
    YY(NDX) = Y
    end if
    if (BOARD(Y, A)) then exit for
  next
  
  for Y = B + 1 to 7 step 1
    if ID <> sgn(BOARD(Y, A)) then
    NDX = NDX + 1
    XX(NDX) = A
    YY(NDX) = Y
    end if
    if (BOARD(Y, A)) then exit for
  next
end sub

sub SHOWBD
  print chr(201, 205, 205) & " A B C D E F G H " & chr(205, 205, 187)
  print chr(186) & "                     " & chr(186)
  for B = 0 to 7
    print CHR$(56 - B) & "   ";
    for A = 0 to 7
      call SHOWMAN(A, B, 0)
      print " ";
    next
    print "  " & CHR$(56 - B)
  next
  print chr(186) & "                     " & chr(186)
  print chr(200, 205, 205) & " A B C D E F G H " & chr(205, 205, 188)
end sub

sub SHOWMAN(A, B, FLAG)
  N$ = "."
  PIECE = int(abs(BOARD(B, A)))
  if PIECE = 100 then N$ = "P"
  if PIECE = 270 then N$ = "N"
  if PIECE = 300 then N$ = "B"
  if PIECE = 500 then N$ = "R"
  if PIECE = 900 then N$ = "Q"
  if PIECE = 5000 or PIECE = 7500 then N$ = "K"
  if board(b, a) < 0 then N$ = lcase(N$, true)
  print N$;
end sub
