#include once "MultiLineEditBox_Basis.bas"

namespace sGUI

declare function AddStringGadget(event as EventHandle ptr,PosX as integer,PosY as integer,NumChars as integer,Text as string="",MaxChars as integer=0 ,CharLimitation as integer=0,ShowEnd as integer=0,Focus as integer=0) as Gadget ptr
declare function StringGadgetActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawStringGadget (gad as Gadget ptr)

declare sub StringGadgetSubHandle(gad as Gadget ptr)
declare sub UpdateStringGadgetBox(gad as Gadget ptr)

declare function GetString (gad as Gadget ptr) as string
declare sub SetString (gad as Gadget ptr,Text as string)
declare sub ScrollToAnEnd (gad as Gadget ptr)

'Ctrl(0) Zeichenbegrenzung 0=String,1=integer,2=Fliekomma,3=binr,4=hexadezimal,5=IP
'Ctrl(1) Schalter "Zeige Stringende"
'Ctrl(2) Focus
'Ctrl(3) maximale Anzahl der Zeichen im String
function AddStringGadget(event as EventHandle ptr,PosX as integer,PosY as integer,NumChars as integer,Text as string="",MaxChars as integer=0 ,CharLimitation as integer=0,ShowEnd as integer=0,Focus as integer=0) as Gadget ptr
  function=0
  dim as Gadget ptr gad
  gad=event->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->event=event
    gad->sel=0
    gad->act=0
    gad->posx=PosX
    gad->posy=PosY
    gad->gadw=NumChars*8 + 6'6 >> Rand
    gad->gadh=fontheight + 6'6 >> Rand

    gad->Ctrl(0)=CharLimitation
    gad->Ctrl(1)=ShowEnd
    gad->Ctrl(2)=Focus
    gad->Ctrl(3)=MaxChars
    
    gad->subevent=new EventHandle
    if gad->subevent then
      gad->gad(0)=AddMLEBGadget(gad->subevent,PosX,PosY,NumChars,1,1)
    end if

    gad->DoDraw     =@DrawStringGadget
    gad->DoAction   =@StringGadgetActions
    gad->DoUpdate   =@DrawStringGadget


    gad->TObject=gad->gad(0)->TObject'Verbindung zum Textobjekt erzeugen das eigentlich zur MLEB in gad(0) gehrt

    if Text<>"" then
      gad->TObject->AppendLine(Text)
      UpdateGadget(gad->gad(0))
    end if
    ScrollToAnEnd(gad)

		gad->SaveBackGround
		function=gad
  end if
end function



function StringGadgetActions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as integer enable
  select case action

      case GADGET_HIT
        StringGadgetSubHandle(gad)
        SetSelect(gad->gad(0),1)
        function=-1

      case GADGET_HOLD,GADGET_HOLDOFF,GADGET_RELEASE,GADGET_RELEASEOFF
        StringGadgetSubHandle(gad)

      case GADGET_KEYBOARD   'Keyboardauswertung
        'ob eine Taste gedrckt wurde, ist schon in GadgetControl berprft worden
        'wenn man bis hierher gelangt ist, wurde etwas gedrckt
        if  EXTENDED then
          'Cursorbewegung mit Pfeiltasten
          if ASCCODE=75 then gad->TObject->CursorLeft
          if ASCCODE=77 then gad->TObject->CursorRight
          'added by MilkFreeze, modified by Muttonhead :D
          if ASCCODE=71 then gad->TObject->CursorKeyPos1
          if ASCCODE=79 then gad->TObject->CursorKeyEnd
          TraceCursorPosition(gad->gad(0))
          DrawGadget(gad->gad(0))
          'DEL Windows
          #ifdef __fb_win32__
            if ASCCODE=83 then
              gad->TObject->KeyDelete
              TraceCursorPosition(gad->gad(0))
              DrawGadget(gad->gad(0))
            end if
          #endif

        else

          'BACKSPACE
          if ASCCODE=8 then
            gad->TObject->KeyBackspace
            TraceCursorPosition(gad->gad(0))
            DrawGadget(gad->gad(0))
          end if

          'DEL Linux
          #ifdef __fb_linux__
            if ASCCODE=127 then
              gad->TObject->KeyDelete
              TraceCursorPosition(gad->gad(0))
              DrawGadget(gad->gad(0))
            end if
          #endif

          'Return
          if ASCCODE=13 then
            ScrollToAnEnd(gad)
            if gad->Ctrl(2) then function=-2 else function=-1'bei Focus bleibt das Control activ(return -2). ansonsten Ausstieg mit -1
          end if

          'Zeicheneingabe
          enable=0

          'Beschrnkungen bei der Zeicheneingabe
          select case gad->Ctrl(0)
            case 0'String
             'Linux chr(127) (Delete) ausschlieen
              #ifdef __fb_linux__
                if ASCCODE>=32 and ASCCODE<>127 then enable=1
              #endif

              'Windows
              #ifdef __fb_win32__
                if ASCCODE>=32 then enable=1
              #endif

            case 1'Ganze Zahlen
              if ASCCODE>47 and ASCCODE<58 then enable=1


            case 2'Fliekomma
              if ASCCODE>47 and ASCCODE<58 then enable=1
              if ASCCODE=46 and instr(TO_GetLineContent(gad,1),".")=0 then enable=1 'wenn . gedrckt und noch kein . im String ist


            case 3'binr
              if ASCCODE>47 and ASCCODE<50 then enable=1

            case 4'hexadezimal
              if ASCCODE>47 and ASCCODE<58 then enable=1
              if ASCCODE>64 and ASCCODE<71 then enable=1
              if ASCCODE>96 and ASCCODE<103 then enable=1

            case 5'IPAdressen  ;)
              if ASCCODE>47 and ASCCODE<58 then enable=1
              if ASCCODE>64 and ASCCODE<71 then enable=1
              if ASCCODE>96 and ASCCODE<103 then enable=1
              if ASCCODE=46 then enable=1
          end select

          'Lngenbegrenzung
          if (gad->Ctrl(3)>0) and (len(TO_GetLineContent(gad,1))>=gad->Ctrl(3)) then enable=0
          
          'generelles Minus Override, es fehlt etwas an Eleganz :/
          if (ASCCODE=45) and (TO_GetCursorPosition(gad)=1) and (instr(TO_GetLineContent(gad,1),"-")=0) then enable=1 'wenn - gedrckt und noch kein - im String ist

          if enable then
            gad->TObject->KeyAddChar(KEY)
            TraceCursorPosition(gad->gad(0))
            DrawGadget(gad->gad(0))
          end if
        end if

      case GADGET_KEYBOARDOFF'Abbruch Keyboardauswertung
        ScrollToAnEnd(gad)
        SetSelect(gad->gad(0),0)

        function=0

  end select
end function



sub DrawStringGadget (gad as Gadget ptr)
  DrawGadget(gad->gad(0))
end sub



sub StringGadgetSubHandle(gad as Gadget ptr)
  gad->subevent->GadgetControl
  if gad->subevent->GADGETMESSAGE then
    select case gad->subevent->GADGETMESSAGE
      case gad->gad(0)
        TraceCursorPosition(gad->gad(0))
    end select
    DrawGadget(gad->gad(0))
  end if
end sub



function GetString (gad as Gadget ptr) as string
  function=gad->TObject->GetLineContent(1)
end function



sub SetString (gad as Gadget ptr,Text as string)
  if TO_GetLines(gad->gad(0))=0 then 
    gad->TObject->AppendLine(Text)
  else
    gad->TObject->SetLineContent(1,Text)
  end if
  
  UpdateGadget(gad->gad(0))
  ScrollToAnEnd(gad)
  DrawGadget(gad->gad(0))
end sub



sub ScrollToAnEnd (gad as Gadget ptr)
  if gad->Ctrl(1)=1 then
    HScrollMLEB(gad->gad(0),1)'erst Scrollfenster (virtuell) ganz nach links schieben
    gad->TObject->CursorKeyEnd  'dann Cursor nach rechts an Textende schieben
    'dadurch ist immer das Ende des Textes im StringGadget zu sehen
    'Da nun das "Cursorverfolgen" von links(Textanfang) erfolgt
  else
    gad->TObject->CursorKeyPos1
  end if
  TraceCursorPosition(gad->gad(0))
end sub

end namespace
