namespace sGUI

declare function AddTrackBar(event as EventHandle ptr,PosX as integer,PosY as integer,TBLength as integer,Minimum as integer,Maximum as integer,ScrollValue as integer,Orientation as integer) as Gadget ptr
declare function TrackBarActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawTrackBar (gad as Gadget ptr)

declare sub AnalogSlideTrackBar(gad as Gadget ptr,knobpos as integer)
declare sub SetTrackBarVal (gad as Gadget ptr,ScrollValue as integer)
declare function GetTrackBarVal (gad as Gadget ptr) as integer

'Steuerungsvariablen TrackBar:
'Ctrl(0)  Minimalwert den .value als Rckgabewert annehmen kann
'Ctrl(1)  Maximalwert den .value als Rckgabewert annehmen kann
'Ctrl(2)  Position des Knobs in px, ergibt sich aus dem Wert in .value
'Ctrl(3)  Mausoffset beim Klicken auf den Knob
'Ctrl(4)  Schalter fr Sliding-Modus
'Ctrl(5)  Schalter vertikal(1)/horizontal(0)
'Ctrl(14) alter Scrollwert um Vernderung des ->Ctrl(15) festzustellen
'Ctrl(15) Scrollwert
function AddTrackBar (event as EventHandle ptr,PosX as integer,PosY as integer,TBLength as integer,Minimum as integer,Maximum as integer,ScrollValue as integer,Orientation as integer) as Gadget ptr
  function=0
  dim as Gadget ptr gad
  gad=event->GadgetList->AppendNew (GadgetType)
  if gad then
    dim as integer range
  
    if Maximum<Minimum then Maximum=Minimum
  
    if ScrollValue>Maximum then ScrollValue=Maximum
    if ScrollValue<Minimum then ScrollValue=Minimum

    gad->event=event
  	gad->sel=0
    gad->act=0
    gad->posx=PosX
    gad->posy=PosY
    'gad->gadw=GadWidth 'weiter unten
    'gad->gadh=GadHeight 'weiter unten

    gad->Ctrl(0)=Minimum
    gad->Ctrl(1)=Maximum
    gad->Ctrl(5)=Orientation
    gad->Ctrl(14)=ScrollValue
    gad->Ctrl(15)=ScrollValue

    range=gad->Ctrl(1) - gad->Ctrl(0)
    if gad->Ctrl(5) then
     'vertikal
      gad->gadw=22
      gad->gadh=TBLength
      if range then gad->Ctrl(2)=(gad->Ctrl(15)-gad->Ctrl(0))/range * (gad->gadh-11)
    else
      'horizontal
      gad->gadw=TBLength
      gad->gadh=22
      if range then gad->Ctrl(2)=(gad->Ctrl(15)-gad->Ctrl(0))/range * (gad->gadw-11)
    end if

    gad->DoDraw     =@DrawTrackBar
    gad->DoAction   =@TrackBarActions
    gad->DoUpdate   =@DrawTrackBar

		gad->SaveBackGround
		function=gad
  end if
end function



function TrackBarActions(gad as Gadget ptr,action as integer) as integer
  function=0

  select case action
      
      case GADGET_HIT        'Control grad frisch gedrckt
        gad->Ctrl(14)=GetTrackBarVal(gad)
        if gad->Ctrl(5) then
          'vertikal
          if MOUSEY-gad->posy>=gad->Ctrl(2) and _           'Knob Treffer
            MOUSEY-gad->posy<gad->Ctrl(2)+11 then
            gad->Ctrl(3)=(MOUSEY-gad->posy)-gad->Ctrl(2) 'Speichern des MouseOffsets berm Knob
            gad->Ctrl(4)=1 'SliderModus bei Hold aktivieren
            SetSelect (gad,1)
          else  'anderenfalls Knob jeweils um 1 in Richtung Mausposition verschieben, kein HOLD
            if MOUSEY < gad->posy + gad->Ctrl(2) then
              SetTrackBarVal(gad,GetTrackBarVal(gad)-1)
            elseif MOUSEY >= gad->posy+ gad->Ctrl(2) + 11 then
              SetTrackBarVal(gad,GetTrackBarVal(gad)+1)
            end if
            gad->Ctrl(4)=0
          end if
        else
          'horizontal
          if MOUSEX-gad->posx>=gad->Ctrl(2) and _           'Knob Treffer
            MOUSEX-gad->posx<gad->Ctrl(2)+11 then
            gad->Ctrl(3)=(MOUSEX-gad->posx)-gad->Ctrl(2) 'Speichern des MouseOffsets berm Knob
            gad->Ctrl(4)=1 'SliderModus bei Hold aktivieren
            SetSelect (gad,1)
          else  'anderenfalls Knob jeweils um 1 in Richtung Mausposition verschieben, kein HOLD
            if MOUSEX < gad->posx + gad->Ctrl(2) then
              SetTrackBarVal(gad,GetTrackBarVal(gad)-1)
            elseif MOUSEX >= gad->posx + gad->Ctrl(2) + 11 then
              SetTrackBarVal(gad,GetTrackBarVal(gad)+1)
            end if
            gad->Ctrl(4)=0
          end if
      
        end if
        if gad->Ctrl(14)<>GetTrackBarVal(gad) then function=1

      case GADGET_HOLD,GADGET_HOLDOFF       'Control wird gehalten, Maus ber/neben dem Control
        if gad->Ctrl(4)=1 then
          gad->Ctrl(14)=GetTrackBarVal(gad)
          if gad->Ctrl(5) then  'vertikal
            AnalogSlideTrackBar(gad,MOUSEY- gad->posy-gad->Ctrl(3))
          else                'horizontal
            AnalogSlideTrackBar(gad,MOUSEX- gad->posx-gad->Ctrl(3))
          end if
          if gad->Ctrl(14)<>GetTrackBarVal(gad) then function=1
        end if

      'case GADGET_HOLDOFF    'Control wird gehalten, Maus neben dem Control

      case GADGET_RELEASE,GADGET_RELEASEOFF    'Control regulr losgelassen/Control losgelassen, dabei ist Maus neben dem Control
        gad->Ctrl(4)=0
        SetSelect(gad,0)
      
      'case GADGET_RELEASEOFF 'Control losgelassen, dabei ist Maus neben dem Control

  end select
end function



sub DrawTrackBar (gad as Gadget ptr)
	dim as integer i,PosX,PosY,GadWidth,GadHeight,p,s,range
  PosX   =gad->posx
	PosY   =gad->posy
	GadWidth		=gad->gadw
	GadHeight		=gad->gadh
	p		=gad->Ctrl(2)
	range=gad->Ctrl(1) - gad->Ctrl(0)

  screenlock
	if gad->act=0 then
    put(PosX,PosY),gad->Background,pset
  else
    put(PosX,PosY),gad->Background,pset
    if gad->Ctrl(5) then'vertikal
      'Slot PosX+10,PosY,GadHeight,1
      ClearBox PosX+9,PosY,4,GadHeight,GadgetColor
      FrameB PosX+9,PosY,4,GadHeight,1
      
      FrameB PosX,PosY+p,22,11,gad->sel
      FillB PosX+1,PosY+p+1,20,9,GadgetColor,gad->sel'Knob
    else'horizontal
      'Slot PosX,PosY+10,GadWidth,0
      ClearBox PosX,PosY+9,GadWidth,4,GadgetColor
      FrameB PosX,PosY+9,GadWidth,4,1
      
      FrameB PosX+p,PosY,11,22,gad->sel
      FillB PosX+p+1,PosY+1,9,20,GadgetColor,gad->sel'Knob
    end if
    if gad->act=2 then put(PosX,PosY),gad->Background,alpha,SleepShade 'Shade (PosX, PosY,GadWidth, GadHeight,gad->Background)
  end if
  screenunlock
end sub



sub AnalogSlideTrackBar(gad as Gadget ptr,knobpos as integer)
	dim as integer range,TBLength
  range=gad->Ctrl(1) - gad->Ctrl(0)

  if gad->Ctrl(5) then TBLength=gad->gadh else TBLength=gad->gadw ' vert.-->TBLength=gadh  /  horiz.-->TBLength=gadw

  if knobpos<0 then knobpos=0
  if knobpos>TBLength-11 then knobpos=TBLength-11

  gad->Ctrl(2)=knobpos
  if range then gad->Ctrl(15)=gad->Ctrl(0)  +  cint(range*gad->Ctrl(2)/(TBLength-11))

  DrawGadget(gad)
end sub



sub SetTrackBarVal (gad as Gadget ptr,ScrollValue as integer)
	dim as integer range,TBLength
  range=gad->Ctrl(1) - gad->Ctrl(0)

  if gad->Ctrl(5) then TBLength=gad->gadh else TBLength=gad->gadw ' vert.-->TBLength=gadh  /  horiz.-->TBLength=gadw

  if ScrollValue>gad->Ctrl(1) then ScrollValue=gad->Ctrl(1)
  if ScrollValue<gad->Ctrl(0) then ScrollValue=gad->Ctrl(0)

  gad->Ctrl(15)=ScrollValue
  if range then gad->Ctrl(2)=(gad->Ctrl(15)-gad->Ctrl(0))/range * (TBLength-11)

  DrawGadget(gad)
end sub



function GetTrackBarVal (gad as Gadget ptr) as integer
	function=gad->Ctrl(15)
end function

end namespace
